=== debian/changelog ===
veyon (4.7.3+repack1-1.1build1) kinetic; urgency=medium

  * No-change rebuild against Qt 5.15.6.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 17 Sep 2022 10:03:58 +0300

veyon (4.7.3+repack1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add a patch to add missing includes for GCC 12 (closes: #1013060).

 -- Dmitry Shachnev <mitya57@debian.org>  Fri, 12 Aug 2022 14:38:21 +0300

veyon (4.7.3+repack1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/docs:
    + Drop CONTRIBUTORS. File vanished upstream.
  * debian/patches:
    + Trivial rebase of 2001_disable-CPackDefinitions-cmake.patch.
    + Drop 2002_no-bundled-kitemmodels.patch. Feature provided upstream.
    + Add 1001_fix-external-x11vnc.patch. Fix build with external x11vnc.
  * debian/veyon-plugins.install:
    + Simplify file, make it more robust to plugin changes.
  * debian/rules:
    + Obtain upstream tarball from Git releases (and import Git submodules
      when creating it).
    + Build with -DWITH_UNITY_BUILD=OFF.
  * debian/watch:
    + Fix for URL changes on Github.
  * debian/control:
    + Adapt S: fields as proposed by upstream.
    + Bump Standards-Version: to 4.6.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 14 Apr 2022 01:38:16 +0200
