## veyon 4.7.4+repack1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,7 @@
 option(WITH_THREAD_SANITIZER "Build with thread sanitizer" OFF)
 option(WITH_UB_SANITIZER "Build with undefined behavior sanitizer" OFF)
 option(WITH_FUZZERS "Build LLVM fuzzer tests (implies WITH_TESTS=ON)" OFF)
+option(WITH_BUILTIN_LIBVNC "Build with built-in LibVNCServer/Client" OFF)
 
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
@@ -46,7 +47,11 @@
 		include(CheckPIESupported)
 		check_pie_supported(LANGUAGES CXX)
 		if(CMAKE_CXX_LINK_PIE_SUPPORTED)
-			set(CMAKE_COMPILE_FLAG_PIE "-fPIE")
+			set(CMAKE_COMPILE_OPTIONS_PIE "-fPIE")
+			set(CMAKE_LINK_OPTIONS_PIE "-pie;-fPIE;-fPIC")
+		else()
+			set(CMAKE_COMPILE_OPTIONS_PIE "-fPIC")
+			set(CMAKE_LINK_OPTIONS_PIE "-fPIC")
 		endif()
 	endif()
 endif()
@@ -104,7 +109,7 @@
 if(NOT VERSION_STRING)
 	set(VERSION_MAJOR 4)
 	set(VERSION_MINOR 7)
-	set(VERSION_PATCH 3)
+	set(VERSION_PATCH 4)
 	set(VERSION_BUILD 0)
 	set(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 else()
