=== core/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,9 @@
 	${CMAKE_CURRENT_BINARY_DIR}/builddata.qrc
 	)
 
-find_package(LibVNCClient 0.9.13)
+if(NOT WITH_BUILTIN_LIBVNC)
+	find_package(LibVNCClient 0.9.13)
+endif()
 
 if(LibVNCClient_FOUND)
 	set_property(GLOBAL PROPERTY HAVE_LIBVNCCLIENT TRUE)
@@ -31,7 +33,7 @@
 		${libvncserver_DIR}/common/turbojpeg.c)
 
 	set_source_files_properties(${libvncclient_SOURCES} PROPERTIES
-		COMPILE_FLAGS "-Wno-unused-function -Wno-unused-variable -fvisibility=default"
+		COMPILE_FLAGS "-Wno-unused-function -Wno-unused-variable -fvisibility=default -Wno-deprecated-declarations"
 		SKIP_PRECOMPILE_HEADERS TRUE)
 endif()
 
@@ -111,7 +113,8 @@
 	target_precompile_headers(veyon-core PRIVATE ${PCH})
 
 	add_pch_target(veyon-application-pch ${PCH})
-	set_target_properties(veyon-application-pch PROPERTIES COMPILE_FLAGS "${CMAKE_COMPILE_FLAG_PIE}")
+	set_target_properties(veyon-application-pch PROPERTIES COMPILE_OPTIONS "${CMAKE_COMPILE_OPTIONS_PIE}")
+	set_target_properties(veyon-application-pch PROPERTIES LINK_OPTIONS "${CMAKE_LINK_OPTIONS_PIE}")
 
 	add_pch_target(veyon-library-pch ${PCH})
 	set_target_properties(veyon-library-pch PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
