=== debian/changelog ===
veyon (4.7.4+repack1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0001_add-missing-includes.patch. Applied upstream.
    + Rebase 2001_disable-CPackDefinitions-cmake.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 20 Oct 2022 22:51:21 +0200
